CREATE OR REPLACE PROCEDURE EAM_IMPORTA_NOTAFISCAL(V_ERRO OUT VARCHAR2)
IS
   V_CODTRANSACAO VARCHAR2(44);
   V_FILIAL       VARCHAR2(20);
   V_DTENTRSAID   DATE;
   V_CDSERVICO    VARCHAR2(10);
   V_VRSERVICO    FLOAT;

   V_CDFILIAL    VARCHAR2(4);
   V_CDSERIE     VARCHAR2(5);
   V_CDEMPRESA   VARCHAR2(2);
   V_CDINSCESTA  VARCHAR2(16);
   V_CDINSCMUNI  VARCHAR2(16);
   V_CDFILIALREC VARCHAR2(4);
   V_CDCLIENTE   VARCHAR2(21);
   V_IDTPIJURCLI VARCHAR2(1);
   V_NRINSJURCLI VARCHAR2(20);
   V_CDTPCTRECEB VARCHAR2(6);
   V_DSCONTAREC  VARCHAR2(200);
   V_CDCLASSFINA VARCHAR2(6);
   V_CDCENTCUST  VARCHAR2(4);

   V_NRLANCTONF VARCHAR2(20);
   V_NRNOTACREC VARCHAR2(20);
   V_NRLANCCONT VARCHAR2(20);
   V_BOLETORECE VARCHAR2(20);

   V_IDUTILVENC VARCHAR2(1);
   V_MODDOCFISC VARCHAR2(2);
   V_NRTAMNUMNFUT NUMBER;

   V_CONTADOR  INTEGER;
   V_RESULTADO VARCHAR2(500);
   V_USR_CODINTERNO VARCHAR2(20);
   V_CDCNPJ_CPF VARCHAR2(20);
   V_IDMOVFLUXO VARCHAR2(1);
   V_IDSTATUS   VARCHAR2(1);
	V_CODBOLETO  VARCHAR2(10);
	V_COUNTBOLETO FLOAT;
   V_RETORNO  NUMBER;
   V_ROWID UROWID;
   V_IDSISTEMA VARCHAR2(10);
   V_COUNT NUMBER;

   CURSOR C_NOTAFISCAL IS
      SELECT U.CODTRANSACAO, U.FILIAL, U.DTVENCIMENTO, U.CDSERVICO, U.VRORIGINAL, U.ROWID, U.USR_CODINTERNO, IDSTATUS, CODBOLETO, CDCNPJ_CPF
        FROM USR_EAM_NOTAFISCAL U
       WHERE U.DTIMPORTACAO IS NULL
         AND U.ERRO IS NULL;
BEGIN

   OPEN C_NOTAFISCAL;
   LOOP
      FETCH C_NOTAFISCAL INTO V_CODTRANSACAO, V_FILIAL, V_DTENTRSAID, V_CDSERVICO, V_VRSERVICO, V_ROWID, V_USR_CODINTERNO, V_IDSTATUS,V_CODBOLETO, V_CDCNPJ_CPF;
      EXIT WHEN C_NOTAFISCAL%NOTFOUND;

      V_ERRO := NULL;

       INSERT INTO USR_EAM_AJUSTE(CODTRANSACAO, CODBOLETO, VRAJUSTE, CODAJUSTE, USR_DTIMP)
       SELECT CODTRANSACAO, TO_NUMBER(CODBOLETO), VRDESCONTO, '0005', TRUNC(SYSDATE)
         FROM USR_EAM_NOTAFISCAL
        WHERE VRDESCONTO > 0
          AND CODTRANSACAO = V_CODTRANSACAO;
      IF V_IDSTATUS = 'I' THEN
         /*  VERIFICA SE A TRANSAO J FOI IMPORTADA */
         BEGIN
            SELECT CDFILIAL
              INTO V_CDFILIALREC
              FROM NOTAFISCAL
             WHERE USR_CODTRANSACAO = V_CODTRANSACAO;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDFILIALREC := NULL;
            WHEN DUP_VAL_ON_INDEX THEN
               V_CDFILIALREC := 'ERRO';
         END;

         IF (V_CDFILIALREC IS NOT NULL) THEN
            UPDATE USR_EAM_NOTAFISCAL
               SET ERRO = 'A TRANSAO DE CDIGO '||V_CODTRANSACAO||' FOI IMPORTADA ANTERIORMENTE'
             WHERE CODTRANSACAO = V_CODTRANSACAO
               AND ROWID = V_ROWID;

            CONTINUE;
         END IF;

         BEGIN
            SELECT F.CDFILIAL, F.CDSERIE, F.CDEMPRESA, F.CDINSCESTA, F.CDINSCMUNI, NVL(P.NRTAMNUMNFUT, 7)
              INTO V_CDFILIAL, V_CDSERIE, V_CDEMPRESA, V_CDINSCESTA, V_CDINSCMUNI, V_NRTAMNUMNFUT
              FROM PARAMFILIAL P, FILIAL F
             WHERE P.CDFILIAL = F.CDFILIAL
               AND CDEXFILIAL = V_FILIAL;
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDFILIAL := NULL;
               V_ERRO := 'NO FOI ENCONTRADA UMA FILIAL COM O CDIGO '||V_FILIAL;
            WHEN DUP_VAL_ON_INDEX THEN
               V_CDFILIAL := NULL;
               V_ERRO := 'MAIS DE UMA FILIAL CADASTRADA COM O CDIGO '||V_FILIAL;
            WHEN OTHERS THEN
               V_CDFILIAL := NULL;
               V_ERRO := 'CDIGO '||V_FILIAL||'. ERRO =>'||SQLERRM(SQLCODE);
         END;

         IF (V_CDFILIAL IS NOT NULL) THEN
            BEGIN
             SELECT CDCLIENTE, IDTPIJURCLIE, NRINSJURCLIE, LPAD(SUBSTR(V_CDSERVICO,1,6), 6, '0')
                 INTO V_CDCLIENTE, V_IDTPIJURCLI, V_NRINSJURCLI, V_CDTPCTRECEB
                 FROM
                 (SELECT  CDCLIENTE, IDTPIJURCLIE, NRINSJURCLIE
                    FROM CLIENTE
                   WHERE USR_CODINTERNO = V_USR_CODINTERNO
                   UNION
                  SELECT CDCLIENTE, IDTPIJURCLIE, NRINSJURCLIE
                    FROM CLIENTE
                   WHERE REGEXP_REPLACE(NRINSJURCLIE, '\D') = REGEXP_REPLACE(V_CDCNPJ_CPF, '\D'));
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_CDCLIENTE := NULL;
                  V_ERRO := 'NO FOI ENCONTRADO UM CLIENTE COM A INSCRIO '||NVL(V_CDCNPJ_CPF, V_USR_CODINTERNO);
               WHEN DUP_VAL_ON_INDEX THEN
                  V_CDCLIENTE := NULL;
                  V_ERRO := 'MAIS DE UM CLIENTE CADASTRADO COM O CDIGO '||NVL(V_CDCNPJ_CPF, V_USR_CODINTERNO);
               WHEN OTHERS THEN
                  V_CDCLIENTE := NULL;
                  V_ERRO := 'CDIGO '||NVL(V_CDCNPJ_CPF, V_USR_CODINTERNO)||'. ERRO =>'||SQLERRM(SQLCODE);
            END;

            IF (V_CDCLIENTE IS NOT NULL) AND (V_CDSERIE IS NOT NULL)  THEN
               NOVO_CODIGO_NT('LANCNF/FILIAL'||V_CDFILIAL, V_NRLANCTONF);
               NOVO_CODIGO_NT('NRNOTAFISCREC', V_NRNOTACREC);
               NOVO_CODIGO_NT('LANCCONTABIL'||V_CDEMPRESA||TO_CHAR(V_DTENTRSAID, 'YYYYMM'), V_NRLANCCONT);


               V_NRLANCTONF := SUBSTR(V_NRLANCTONF, -10);
               V_NRNOTACREC := SUBSTR(V_NRNOTACREC, V_NRTAMNUMNFUT*(-1));
               V_NRLANCCONT := TO_CHAR(V_DTENTRSAID, 'YYYYMM')||SUBSTR(V_NRLANCCONT,-6);


               BEGIN
                  INSERT INTO NOTAFISCAL(CDFILIAL, NRLANCTONF, CDEMPRESA, CDINSCESTA, CDINSCMUNI, CDFILIEMIT,
                                         IDTPIJURNF, NRINSJURNF, CDCLIENTE, IDBLOQUEADO, IDDOCFISCAL, IDDOCFINANC,
                                         VRPRODUTOS, VRNOTAFISC, NRNOTAFISC, DTEMISSAO, DTENTRSAID, IDENTRSAIDOP,
                                         CDTIPOOPER, CDSERIE, IDDOCCONTAB, IDSTATUS, NRLANCTBDOC, IDDOCFISCENT,
                                         IDDOCFISCSAI, IDDOCESTOQUE, IDSISTEMA, DTLANCAMENNF, USR_CODTRANSACAO)
                  VALUES(V_CDFILIAL, V_NRLANCTONF, V_CDEMPRESA, V_CDINSCESTA, V_CDINSCMUNI, V_CDFILIAL,
                         V_IDTPIJURCLI, V_NRINSJURCLI, V_CDCLIENTE, 'S', 'N', 'S',
                         V_VRSERVICO, V_VRSERVICO, V_NRNOTACREC, V_DTENTRSAID, V_DTENTRSAID, 'S',
                         '13', V_CDSERIE, 'S', 'A', V_NRLANCCONT, 'N',
                         'S', 'N', 'REC', V_DTENTRSAID, V_CODTRANSACAO);
               EXCEPTION
                  WHEN OTHERS THEN
                     ROLLBACK;
                     V_ERRO := 'ERRO AO GERAR A NOTA. ERRO => '||SQLERRM(SQLCODE);
               END;

               IF (V_ERRO IS NULL) THEN
					   BEGIN
							SELECT NRLANBOLREC
							  INTO V_BOLETORECE
							  FROM BOLETRECEBER
							 WHERE USR_CODBOLETO = V_CODBOLETO
							   AND IDSTATBREC = 'A'
                        AND CDCLIENTE = V_CDCLIENTE
                        AND DTVENBOLREC = V_DTENTRSAID;
						EXCEPTION
                     WHEN NO_DATA_FOUND THEN
                        V_COUNTBOLETO := 0;
                  END;

						IF (V_BOLETORECE IS NULL ) THEN
                     NOVO_CODIGO_NT('BOLETRECEBER'||V_CDFILIAL, V_BOLETORECE);
                     V_BOLETORECE := SUBSTR(V_BOLETORECE, -10);
							BEGIN
								INSERT INTO BOLETRECEBER(CDFILIAL, NRLANBOLREC, CDCLIENTE, CDEMPRESA, VRBOLREC, VRFINALBREC, DTVENBOLREC, CDTPBAIXAREC, VRPEMULBREC,
																 VRMULTABREC , VRPEMORBREC , VRMORDIABREC, USR_CODBOLETO)
								VALUES(V_CDFILIAL, V_BOLETORECE, V_CDCLIENTE, V_CDEMPRESA, V_VRSERVICO, V_VRSERVICO, V_DTENTRSAID, NULL, 0,
										 0, 0, 0, V_CODBOLETO);
							EXCEPTION
								WHEN OTHERS THEN
									ROLLBACK;
									V_ERRO := 'ERRO AO GERAR O BOLETO. ERRO => '||SQLERRM(SQLCODE);
							END;
						ELSE
							BEGIN
								UPDATE BOLETRECEBER
									SET VRFINALBREC   = ROUND(VRFINALBREC + V_VRSERVICO,2),
                               VRBOLREC = ROUND(VRBOLREC + V_VRSERVICO,2)
								 WHERE USR_CODBOLETO = V_CODBOLETO
									AND IDSTATBREC    = 'A'
									AND CDCLIENTE     = V_CDCLIENTE
									AND DTVENBOLREC   = V_DTENTRSAID;
							EXCEPTION
								WHEN OTHERS THEN
									ROLLBACK;
									V_ERRO := 'ERRO AO GERAR O BOLETO. ERRO => '||SQLERRM(SQLCODE);
							END;
						END IF;
               END IF;

               IF (V_ERRO IS NULL) THEN
                  BEGIN
                     BEGIN
                        SELECT DSTPCTRECEB, CDCLASSFINA
                          INTO V_DSCONTAREC, V_CDCLASSFINA
                          FROM TIPOCTRECEBER
                         WHERE CDTPCTRECEB = V_CDTPCTRECEB;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_DSCONTAREC := NULL; V_CDCLASSFINA := NULL;
                           V_ERRO := 'TIPO DE CONTA A RECEBER NO CADASTRADO '||V_CDTPCTRECEB;
                     END;

                     IF (V_CDCLASSFINA IS NOT NULL) THEN
                        BEGIN
                           SELECT IDMOVFLUXO
                             INTO V_IDMOVFLUXO
                             FROM MOVFLUXO
                            WHERE CDCLASSFINA = V_CDCLASSFINA
                              AND CDEMPRESA   = V_CDEMPRESA
                              AND CDFILIAL    = V_CDFILIAL
                              AND DTMOVFLUXO  = V_DTENTRSAID
                              AND IDMOVFLUXO  = 'E';
                        EXCEPTION
                           WHEN NO_DATA_FOUND THEN
                              V_IDMOVFLUXO := NULL;
                        END;

                        IF (V_IDMOVFLUXO IS NULL) THEN
                           INSERT INTO MOVFLUXO(CDCLASSFINA, CDEMPRESA, CDFILIAL, DTMOVFLUXO, IDMOVFLUXO, VRENTMFLUXO, VRSAIMFLUXO)
                           VALUES(V_CDCLASSFINA, V_CDEMPRESA, V_CDFILIAL, V_DTENTRSAID, 'E', V_VRSERVICO, 0);
                        ELSE
                           UPDATE MOVFLUXO
                              SET VRENTMFLUXO = V_VRSERVICO
                            WHERE CDCLASSFINA = V_CDCLASSFINA
                              AND CDEMPRESA   = V_CDEMPRESA
                              AND CDFILIAL    = V_CDFILIAL
                              AND DTMOVFLUXO  = V_DTENTRSAID
                              AND IDMOVFLUXO  = 'E';
                        END IF;
                     END IF;

                     INSERT INTO CONTARECEBER(CDFILIAL, NRLANCTONF, NRSEQVENREC, NRPARCELAREC, DTORIGVENREC, VRATUAREC, CDTPCTRECEB, DTATUAVENREC,
                                              VRORIGREC, CDFILIBOLREC, NRLANBOLREC, IDSTATREC, QTDIASVENREC, DSCONTAREC, CDCLASSFINA, CDEMPRESA,
                                              DTMOVFLUXO, IDMOVFLUXO, CDFIMOVFLREC)
                     VALUES(V_CDFILIAL, V_NRLANCTONF, '01', '00', V_DTENTRSAID, V_VRSERVICO, V_CDTPCTRECEB, V_DTENTRSAID,
                            V_VRSERVICO, V_CDFILIAL, V_BOLETORECE, 'A', 0, V_DSCONTAREC, V_CDCLASSFINA, V_CDEMPRESA,
                            V_DTENTRSAID, 'E', V_CDFILIAL);

                     BEGIN
                        SELECT CDCENTCUST
                          INTO V_CDCENTCUST
                          FROM EMPRESA
                         WHERE CDEMPRESA = V_CDEMPRESA;
                     EXCEPTION
                        WHEN NO_DATA_FOUND THEN
                           V_CDCENTCUST := NULL;
                     END;

                     IF (V_CDCENTCUST IS NULL) THEN
                        BEGIN
                           SELECT MIN(CDCENTCUST)
                             INTO V_CDCENTCUST
                             FROM CENTCUST;
                        EXCEPTION
                           WHEN OTHERS THEN
                              V_CDCENTCUST := NULL;
                        END;
                     END IF;

                     IF (V_CDCENTCUST IS NOT NULL) THEN
                        INSERT INTO RATCTRECEBER(CDFILIAL, NRLANCTONF, NRSEQVENREC, NRPARCELAREC, CDCENTCUST, CDFIRATCTREC, VRRATCCCTREC)
                        VALUES(V_CDFILIAL, V_NRLANCTONF, '01', '00', V_CDCENTCUST, V_CDFILIAL, V_VRSERVICO);

                          UPDATE USR_EAM_NOTAFISCAL
                           SET DTIMPORTACAO = SYSDATE
                         WHERE CODTRANSACAO = V_CODTRANSACAO
                           AND ROWID = V_ROWID;
                     ELSE
                        V_ERRO := 'CENTRO DE CUSTO NO CADASTRADO';
                        ROLLBACK;
                     END IF;
                     CTB_REC_LANC(V_CDFILIAL, V_NRLANCTONF, '00','01', '', '', 'D', V_NRLANCCONT);
                  EXCEPTION
                     WHEN OTHERS THEN
                        ROLLBACK;
                        V_ERRO := 'ERRO AO INSERIR CONTA A RECEBER. ERRO => '||SQLERRM(SQLCODE);
                  END;
               END IF;
            ELSIF (V_CDSERIE IS NULL) THEN
               V_ERRO := 'FILIAL NO POSSUI SRIE PADRO CADASTRADA';
            END IF;
         END IF;
      ELSE
         V_COUNT := 0;
         BEGIN
            SELECT MAX(CDFILIAL), MAX(NRLANCTONF), MAX(CDEMPRESA), MAX(NRLANCTBDOC), MAX(IDSISTEMA)
              INTO V_CDFILIAL, V_NRLANCTONF, V_CDEMPRESA, V_NRLANCCONT, V_IDSISTEMA
              FROM NOTAFISCAL
             WHERE TO_NUMBER(USR_CODTRANSACAO) = TO_NUMBER(V_CODTRANSACAO);
         EXCEPTION
            WHEN NO_DATA_FOUND THEN
               V_CDFILIAL   := NULL;
               V_NRLANCTONF := NULL;
               V_CDEMPRESA  := NULL;
               V_NRLANCCONT := NULL;
               V_IDSISTEMA  := NULL;
         END;
         IF V_IDSISTEMA IN ('BCO', 'PAG', 'REC', 'CNC') THEN
            BEGIN
               SELECT COUNT(*)
                 INTO V_COUNT
                 FROM CONTOPECTBL C, LANCCONT L
                WHERE C.CDEMPRESA = L.CDEMPRESA
                  AND L.NRLANCCONT = V_NRLANCCONT
                  AND L.CDEMPRESA = V_CDEMPRESA
                  AND L.DTLANCCONT BETWEEN C.DTINICCTBL AND C.DTFINACCTBL;
            EXCEPTION
               WHEN NO_DATA_FOUND THEN
                  V_COUNT := 0;

            END;
         END IF;

         IF (V_CDFILIAL IS NOT NULL) AND (V_COUNT <> 0) THEN
            CANCELA_DADOS_FINANCEIRO(V_CDFILIAL,V_NRLANCTONF, 'S',V_RETORNO);

            IF V_RETORNO <> 0 THEN
               V_ERRO := V_ERRO||' ERRO: '||TO_CHAR(V_RETORNO);
               ROLLBACK;
            ELSE
              DELETE FROM CONTARECEBER
               WHERE CDFILIAL   = V_CDFILIAL
                 AND NRLANCTONF = V_NRLANCTONF;
              DELETE FROM LANCCONT
               WHERE CDEMPRESA = V_CDEMPRESA
                 AND NRLANCCONT = V_NRLANCCONT;
              DELETE FROM NOTAFISCAL
               WHERE CDFILIAL   = V_CDFILIAL
                 AND NRLANCTONF = V_NRLANCTONF;

            END IF;
         ELSE
            V_ERRO := 'ERRO: Lancamento fora do perodo contabil para o financeiro';
            ROLLBACK;
         END IF;
         UPDATE USR_EAM_NOTAFISCAL
            SET DTIMPORTACAO = SYSDATE
          WHERE CODTRANSACAO = V_CODTRANSACAO
            AND ROWID = V_ROWID;
      END IF;

      IF (V_ERRO IS NOT NULL) THEN
         UPDATE USR_EAM_NOTAFISCAL
            SET ERRO = V_ERRO
          WHERE CODTRANSACAO = V_CODTRANSACAO
            AND ROWID = V_ROWID;
      END IF;
      V_BOLETORECE := NULL;
      COMMIT;
   END LOOP;
   CLOSE C_NOTAFISCAL;

   COMMIT;
EXCEPTION
   WHEN OTHERS THEN
      IF C_NOTAFISCAL%ISOPEN THEN
         CLOSE C_NOTAFISCAL;
      END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('EAM_IMPORTA_NOTAFISCAL','6.39.033'); END;
/
