CREATE TABLE APROVALCADA (
  NRAPROVALCADA NUMBER(10) NOT NULL, 
  NRCONFIGALCADA NUMBER(10) NOT NULL, 
  CDFILDEST VARCHAR2(4) NOT NULL, 
  CDFILLANC VARCHAR2(4) NOT NULL, 
  NRDEMANDA VARCHAR2(10) NOT NULL, 
  CDOPERADOR VARCHAR2(12) NOT NULL, 
  IDTPDEMANDA VARCHAR2(30) NOT NULL, 
  IDCLASSIFIC VARCHAR2(30) NOT NULL, 
  IDOPERACAOALC VARCHAR2(30) NOT NULL, 
  IDAPROVADO VARCHAR2(30) NOT NULL, 
  DSJUSTIFICA VARCHAR2(4000) DEFAULT NULL NULL, 
  DTAPROVACAO DATE DEFAULT NULL NULL, 
  CDOPERAPROV VARCHAR2(12) DEFAULT NULL NULL, 
  NRORG NUMBER(10) DEFAULT SYS_CONTEXT('nrorg_ctx','nrorg') NOT NULL, 
  IDATIVO VARCHAR2(1) DEFAULT 'S' NOT NULL, 
  DTINCLUSAO DATE DEFAULT NULL NULL, 
  DTULTATU DATE DEFAULT NULL NULL, 
  NRORGINCLUSAO NUMBER(10) DEFAULT 1 NULL, 
  NRORGULTATU NUMBER(10) DEFAULT 1 NULL, 
  CDOPERINCLUSAO VARCHAR2(12) DEFAULT '1' NULL, 
  CDOPERULTATU VARCHAR2(12) DEFAULT '1' NULL,
  CONSTRAINT PK_APROVALCADA PRIMARY KEY(NRAPROVALCADA)
)
/
ALTER TABLE APROVALCADA ADD CONSTRAINT CKC_IDATIVO_APROVALCADA CHECK (IDATIVO IN ('S','N'))
/
ALTER TABLE APROVALCADA ADD CONSTRAINT CKC_IDTPDEMANDA CHECK (IDTPDEMANDA IN ('SOLICITACAO', 'AF', 'PEDIDOOL'))
/
ALTER TABLE APROVALCADA ADD CONSTRAINT CKC_IDCLASSIFIC CHECK (IDCLASSIFIC IN ('EXTRA', 'FORA_ORCAMENTO', 'PADRAO'))
/
ALTER TABLE APROVALCADA ADD CONSTRAINT CKC_IDOPERACAOALC CHECK (IDOPERACAOALC IN ('LANCAMENTO', 'ALTERACAO', 'BAIXA_MANUAL', 'CANCELAMENTO', 'EXCLUSAO'))
/
ALTER TABLE APROVALCADA ADD CONSTRAINT CKC_IDAPROVADO CHECK (IDAPROVADO IN ('APROVADO', 'PENDENTE', 'RECUSADO'))
/
ALTER TABLE APROVALCADA ADD CONSTRAINT UN_APROVALCADA UNIQUE (NRCONFIGALCADA, CDFILDEST, CDFILLANC, NRDEMANDA, CDOPERADOR)
/
ALTER TABLE APROVALCADA ADD CONSTRAINT FKCMP00576CONFIGALCADA FOREIGN KEY (NRCONFIGALCADA) REFERENCES CONFIGALCADA (NRCONFIGALCADA)
/
CREATE INDEX FKCMP00576CONFIGALCADA ON APROVALCADA (NRCONFIGALCADA)
/
ALTER TABLE APROVALCADA ADD CONSTRAINT FKCMP00577FILIAL FOREIGN KEY (CDFILDEST) REFERENCES FILIAL (CDFILIAL)
/
CREATE INDEX FKCMP00577FILIAL ON APROVALCADA (CDFILDEST)
/
ALTER TABLE APROVALCADA ADD CONSTRAINT FKCMP00578FILIAL FOREIGN KEY (CDFILLANC) REFERENCES FILIAL (CDFILIAL)
/
CREATE INDEX FKCMP00578FILIAL ON APROVALCADA (CDFILLANC)
/
ALTER TABLE APROVALCADA ADD CONSTRAINT FKCMP00579OPERADOR FOREIGN KEY (CDOPERADOR) REFERENCES OPERADOR (CDOPERADOR)
/
CREATE INDEX FKCMP00579OPERADOR ON APROVALCADA (CDOPERADOR)